#include <math.h>
#include <stdlib.h>
#include <gsl/gsl_math.h>
#include "../log_density.h"

void transform( double *, int *, double * );

double post( double *theta, int *ip, double *dp )
{

   int i, err;
   double pdf, tmp, *ttheta, *p=theta;

   if( ip[0] ) {
      ttheta = (double *) malloc( ip[1] * sizeof( double ) );
      for( i=0; i<ip[1]; i++ ) {
         ttheta[i] = theta[i];
      }
      transform( ttheta, ip, dp );
      p = ttheta; 
   }
   else {
/* Boundaries for prior 1. */

      for( i=0; i<ip[1]; i++ ) {
         if( p[i] <= dp[ip[3]+i] || p[i] >= dp[ip[3]+ip[1]+i] ) {
            return( HUGE_VAL );
         }
      }
   }

/* Calculate likelihood */

   tmp = 0.0;
   for( i=0; i<ip[2]; i++ ) {
      pdf = log_gamma_pdf( dp[i], p[1], p[2] );
      tmp += pdf + log( p[0] );
   }
   for( i=ip[2]; i<ip[3]; i++ ) {
      pdf = log_invgauss_pdf( dp[i], p[3], p[4] );
      tmp += pdf + log( 1.0 - p[0] );
   }

   if( ip[0] ) {
      free( ttheta );
   }

   err = gsl_finite( tmp );
   if( !err ) {
      return( HUGE_VAL );
   }

   return( -tmp );
}
