source("../evalPost.r")

ip[4] <- 1000
dp[length(dp)] <- 1e-10

th1 <- seq(0.001, 4, length=101)
th2 <- seq(0.001, 10, length=101)

th.grid <- cbind(rep(th1, each=length(th2)), rep(th2, length(th1)))

post.grid <- NULL
system("cp post_map.c post.c")
for( i in 1:dim(th.grid)[1] ) {
   if( i==1 ) { cp <- T; cl <- F;}
   else if( i == dim(th.grid)[1] ) { cp <- F; cl <- T; }
   else { cp <- F; cl <- F; }
   post.grid <- c(post.grid, evalPost(th.grid[i,], ip, dp, id=1,
                                      compile=cp, clean=cl))
}
system("rm post.c")
 
post.grid <- t(matrix(post.grid, nrow=length(th1)))

ip[4] <- M
dp[length(dp)] <- eps

save.image()

lev <- c(seq(-1000, -400, 200), -340, -1500)

iss <- seq(1, N, length=5000)
postscript("eval_post.ps", paper="special", width=6.5, height=4,
           horizontal=FALSE)
op <- par(pty="s", mfrow=c(1,2), mar=c(3,3,0,1), mgp=c(2,1,0),
          cex.axis=0.75, cex.lab=0.75)
contour(th1, th2, post.grid, xlab=expression(lambda), ylab=expression(mu),
        levels=lev, xlim=c(0,3.5))
contour(th1, th2, post.grid, xlab=expression(lambda), ylab=expression(mu),
        levels=lev, xlim=c(0,3.5))
points(Theta[iss,1], Theta[iss,2], col="grey50", cex=0.5)
par(op)
graphics.off()
