#include <math.h>
#include <stdlib.h>
#include <gsl/gsl_math.h>
#include "../log_density.h"

void transform( double *, int *, double * );
void id_08( int *, double *, int *, double *, double *, int *,
            int *, double *, double *, int * );

double post( double *theta, int *ip, double *dp )
{

   int i, err=0, dp_id=ip[3]+ip[6];
   double tmp, *ttheta, *p=theta, *t, *fi;

   if( ip[0] ) {
      ttheta = (double *) malloc( ip[1] * sizeof( double ) );
      for( i=0; i<ip[1]; i++ ) {
         ttheta[i] = theta[i];
      }
      transform( ttheta, ip, dp );
      p = ttheta; 
   }
   else {
/* Boundaries for prior 1. */

      for( i=0; i<ip[1]; i++ ) {
         if( p[i] <= dp[ip[3]+i] || p[i] >= dp[ip[3]+ip[1]+i] ) {
            return( HUGE_VAL );
         }
      }
   }

/* Calculate likelihood */

   tmp = 0.0;

/* Incomplete Data */
   t = (double *) malloc( ip[2] * sizeof( double ) );
   for( i=0; i<ip[2]; i++ ) {
      t[i] = dp[i];
   }
   fi = (double *) calloc( ip[2], sizeof( double ) );

   id_08( &ip[4], &dp[dp_id], &ip[2], t, p, &ip[1], &ip[5],
          &dp[dp_id+1], fi, &err );

   free( t );
   if( err ) {
      free( fi );
      if( ip[0] ) {
         free( ttheta );
      }
      return( HUGE_VAL );
   }
   for( i=ip[2]; i<ip[3]; i++ ) {
      tmp += dp[i] * log( fi[i-ip[2]] );
   }
   free( fi );

   if( ip[0] ) {
      free( ttheta );
   }

   err = gsl_finite( tmp );
   if( !err ) {
      return( HUGE_VAL );
   }

   return( -tmp );
}
