fourier <- function (N, Theta, t, M=100, A=20, maxiter=10, nthread=1,
                     eps=1e-8, info=0, file=FALSE, cdf=FALSE)
{
   if (!is.matrix(Theta)) { Theta <- matrix(Theta, nrow=1) }

   system("ln -s ../Makefile makefile")
   if (cdf) { 
      system("make -f makefile fourier_cdf.so")
   } else {
      system("make -f makefile fourier_df.so")
   }
   system("make -f makefile clean")
   dyn.load("fourier.so")

   List <- .C("fourier", as.integer(M),as.double(A),
              as.integer(length(t)),as.double(t),
              as.double(as.vector(t(Theta))),as.integer(N),
              as.integer(dim(Theta)[2]),as.integer(maxiter),
              as.integer(nthread),as.double(eps),as.integer(info),
              Fi=as.double(numeric(length(t))), err.fi=as.integer(0),
              as.integer(as.numeric(file)))

   dyn.unload("fourier.so")
   system("make -f makefile clean.so; rm makefile")

   err.fi <- List$err.fi
   if( err.fi ) {
      warning("\nError in inversion algorithm.\n")
   }

   list(pd=List$Fi)
}
