#include <math.h>
#include <gsl/gsl_complex.h>
#include <gsl/gsl_complex_math.h>

double m(gsl_complex s, double *th)
{
  double p=th[0], mu=th[1], l1=th[2], l2=th[3],
         a=th[4], b=th[5];
  double t11;
  double t12;
  gsl_complex z1,z2,z3,z4,z5,z6;
  {
    z1 = gsl_complex_negative(gsl_complex_sub_real(s,mu));
    z1 = gsl_complex_mul_real(gsl_complex_inverse(z1),mu);
    z2 = gsl_complex_negative(gsl_complex_sub_real(s,b));
    z2 = gsl_complex_mul_real(gsl_complex_inverse(z2),b);
    z2 = gsl_complex_pow_real(z2,1.0*a);
    t11 = l1*l1;
    t12 = l2*l2;
    z3 = gsl_complex_mul_real(s,2.0);
    z3 = gsl_complex_negative(gsl_complex_sub_real(z3,t12));
    z3 = gsl_complex_mul_real(z3,t11);
    z3 = gsl_complex_sqrt(z3);
    z4 = gsl_complex_negative(gsl_complex_sub_real(z3,l1*l2));
    z4 = gsl_complex_exp(z4);
    z5 = gsl_complex_mul(z1,z2);
    z5 = gsl_complex_mul_real(z5,p);
    z6 = gsl_complex_mul(z1,z4);
    z6 = gsl_complex_mul_real(z6,1.0-p);
    z6 = gsl_complex_negative(gsl_complex_sub_real(z6,1.0));
    return(GSL_REAL( gsl_complex_div(z5,z6) ));
  }
}
