mcvar <- function(y, b=30, method=c("ess", "batch"))
{
   method <- match.arg(method)
   if (method == "ess") {
      lag.max <- 0; k <- 1;

      if (var(y) > 0) {
         while (k == lag.max+1) {
            lag.max <- lag.max+floor(10*log10(length(y)))
            acf.y <- as.vector(acf(y, lag.max=lag.max, plot=FALSE)$acf)
            k <- 1
            while (k <= lag.max && abs(acf.y[k]) >= 0.1) { k <- k+1 }
         }
      }

      if (k == 1) {
         ess <- length(y)
      } else {
         ess <- length(y) / (1+2*sum(acf.y[2:k]))
      }
      return(list(ess=ess, var=var(y)/ess))
   } else {
      B <- sapply(1:b, function (i, k=length(y)/b) { y[(1+(i-1)*k):(i*k)] })
      if (is.null(dim(B))) { B <- matrix(B, nrow=1) }
      bm <- apply(B, 2, mean)
      if (var(bm) > 0) {
         acf.bm <- as.vector(acf(bm, plot=FALSE)$acf)
         return(list(acf=acf.bm[2], var=var(bm)/b))
      }
      return(list(acf=0, var=0))
   }
}
