#include <stdlib.h>

double k25( double, double * );
double dk25( double, double * );
double ddk25( double, double * );

void calc_spb_id( double *, double *, double *, int *, int *, double *,
                  double *, int *, double (*)( double, double * ),
                  double (*)( double, double * ) );
void saddle_id( double *, double *, int *, double *, double *, int *,
                int *, int *, double *, double *, double *, double *,
                double *, int *, double (*)( double, double * ),
                double (*)( double, double * ),
                double (*)( double, double * ) );

void id_25( double m, double M, int *lt, double *t, double *theta,
            int *ntheta, int *max_iter, double *epsrel, double *epsabs,
            double *max_abserr, double *sp, int *err_id )
{
   int N=1, err=0;
   double sp_lb, sp_ub, nc;
   double (*k)(double, double *)=k25, (*dk)(double, double *)=dk25,
          (*ddk)(double, double *)=ddk25;

   calc_spb_id( &m, &M, theta, &N, ntheta, &sp_lb, &sp_ub, &err, k, dk );
   if( err ) {
      *err_id = 1; return;
   }

   saddle_id( &sp_lb, &sp_ub, lt, t, theta, &N, ntheta, max_iter,
              epsrel, epsabs, max_abserr, sp, &nc, &err, k, dk, ddk );
   if( err ) {
      *err_id = 1;
   }
   return;
}
