#include <stdlib.h>
#include <gsl/gsl_statistics.h>

double dk( double, double * );
double ddk( double, double * );

void moments( int *N, int *ntheta, double *theta, double *vdk,
              double *vddk, double *mu, double *var )
{
   int i, j;
   double *th;

   th = (double *) malloc( *ntheta * sizeof( double ) );

   for( i=0; i<*N; i++ ) {
      for( j=0; j<*ntheta; j++ ) {
         th[j] = theta[j+i*(*ntheta)];
      }
      vdk[i] = dk( 0.0, th );
      vddk[i] = ddk( 0.0, th );
   }

   *mu = gsl_stats_mean( vdk, 1, *N );

   *var = gsl_stats_variance_with_fixed_mean( vdk, 1, *N, *mu );
   *var += gsl_stats_mean( vddk, 1, *N );

   free( th );
   return;
}
