#include <math.h>
#include <gsl/gsl_complex.h>
#include <gsl/gsl_complex_math.h>
double m(gsl_complex s, double *th)
{
  double p01=th[0], p10=th[1], l1=th[2],
         l2=th[3], a1=th[4], b1=th[5],
         a2=th[6], b2=th[7], mu=th[8];
  double t2;
  double t3;
  gsl_complex z1,z2,z3,z4,z5,z6;
  {
    t2 = l1*l1;
    t3 = l2*l2;
    z1 = gsl_complex_mul_real(s,2.0);
    z1 = gsl_complex_negative(gsl_complex_sub_real(z1,t3));
    z1 = gsl_complex_mul_real(z1,t2);
    z1 = gsl_complex_pow_real(z1,0.5);
    z1 = gsl_complex_negative(gsl_complex_sub_real(z1,l1*l2));
    z1 = gsl_complex_exp(z1);
    z1 = gsl_complex_mul_real(z1,p01);
    z2 = gsl_complex_negative(gsl_complex_sub_real(s,b1));
    z2 = gsl_complex_inverse(gsl_complex_div_real(z2,b1));
    z2 = gsl_complex_pow_real(z2,1.0*a1);
    z3 = gsl_complex_negative(gsl_complex_sub_real(s,b2));
    z3 = gsl_complex_inverse(gsl_complex_div_real(z3,b2));
    z3 = gsl_complex_pow_real(z3,1.0*a2);
    z4 = gsl_complex_mul_real(z1,(1.0-p10)*mu);
    z4 = gsl_complex_div(z4,gsl_complex_negative(gsl_complex_sub_real(s,mu)));
    z5 = gsl_complex_mul_real(z2,1.0-p01);
    z5 = gsl_complex_add(z4,z5);
    z6 = gsl_complex_mul_real(z3,p10);
    z6 = gsl_complex_mul(z1,z6);
    z6 = gsl_complex_negative(gsl_complex_sub_real(z6,1.0));
    return(GSL_REAL( gsl_complex_div(z5,z6) ));
  }
}
