rejection <- function ( N, ntheta, ll, par.g, ip, dp,
                        seed=round((2^16-1)*runif(1),0), eps=1e-6, outfile="")
{
   system("ln -s ../Makefile makefile; make -f makefile rejection.so;
           make -f makefile clean")
   dyn.load("rejection.so")

   ip <- c(0, ip); fmax <- ll+eps; iter <- 0; sample <- numeric(N * ntheta);

   List <- .C("rejection", Theta = as.double(sample), as.integer(N),
              as.integer(ntheta), as.integer(seed), iter = as.integer(iter),
              as.double(fmax), as.double(par.g), as.integer(ip), as.double(dp))

   dyn.unload("rejection.so")
   system("make -f makefile clean.so; rm makefile")

   write("\n\nREJECTION SAMPLING SUMMARY\n", file=outfile, append=TRUE)
   write(paste("Rejection sampling acceptance rate:\t",
         round(100*N/List$iter,2), "%", sep=""), file=outfile, append=TRUE)

   t(matrix(List$Theta, nrow=ntheta))
}
