f1 <- function (x, p)
{
   dexp(p$t - x, rate=p$th[1]) * dgamma(x, shape=p$th[2], rate=p$th[3])
}

f2 <- function (x, p)
{
   pexp(p$t - x, rate=p$th[1]) * dgamma(x, shape=p$th[2], rate=p$th[3])
}

v <- seq(0, 200, 1)

pd.ex <- sapply(1:length(v), function (t) { print(t);
                mean(sapply(1:N, function (i) { integrate(f1, 0, v[t],
                             p=list(th=Theta[i,], t=v[t]))$value } )) } )

cdf.ex <- sapply(1:length(v), function (t) { print(t);
                 mean(sapply(1:N, function (i) { integrate(f2, 0, v[t],
                             p=list(th=Theta[i,], t=v[t]))$value } )) } )
sf.ex <- 1 - cdf.ex

hf.ex <- pd.ex / sf.ex

# Quantiles

g <- function (x, l)
{
   mean(sapply(1:l$N, function (k) { integrate(f2, 0, x,
                             p=list(th=l$Theta[k,], t=x))$value } )) - l$prob
}

probs <- c(.1, .25, .5, .75, .9, .95, .99)
q <- numeric(length(probs))

for (i in 1:length(probs)) {
   print(i)
   for (j in 1:(length(cdf.ex)-1)) {
      if (cdf.ex[j] < probs[i] && probs[i] < cdf.ex[j+1]) {
         q[i] <- uniroot(g, lower=v[j], upper=v[j+1],
                         l=list(N=N, Theta=Theta, prob=probs[i]))$root
         break
      } 
      else {
         q[i] <- NA
      }
   }
}
