#include <math.h>
#include <stdlib.h>
#include <gsl/gsl_math.h>
#include "../log_density.h"

void transform( double *, int *, double * );

double post( double *theta, int *ip, double *dp )
{

   int i, err;
   double pdf, sf, tmp, *ttheta, *p=theta;

   if( ip[0] ) {
      ttheta = (double *) malloc( ip[1] * sizeof( double ) );
      for( i=0; i<ip[1]; i++ ) {
         ttheta[i] = theta[i];
      }
      transform( ttheta, ip, dp );
      p = ttheta; 
   }
   else {
      for( i=0; i<ip[1]; i++ ) {
         if( p[i] <= dp[ip[4]+i] || p[i] >= dp[ip[4]+ip[1]+i] ) {
            return( HUGE_VAL );
         }
      }
   }

/* Calculate likelihood */

   tmp = 0.0;
   for( i=0; i<ip[2]; i++ ) {
      pdf = log_exponential_pdf( dp[i], p[0] );
      tmp += pdf;
   }
   for( i=ip[2]; i<ip[3]; i++ ) {
      pdf = log_gamma_pdf( dp[i], p[1], p[2] );
      tmp += pdf;
   }
   for( i=ip[3]; i<ip[4]; i++ ) {
      gamma_sf( dp[i], p[1], p[2], &sf );
      sf = log( sf );
      tmp += sf;
   }

   if( ip[0] ) {
      free( ttheta );
   }

   err = gsl_finite( tmp );
   if( !err ) {
      return( HUGE_VAL );
   }

   return( -tmp );
}
